def make_rotator(proxies):

    if not proxies or len(proxies) == 0:
        return lambda: None

    proxy_state = {"index": 0}
    num_proxies = len(proxies)

    # Add a None element to the list of proxies, so that 1/N of the time
    # we'll request from the current address.
    if num_proxies > 0:
        proxies.append(None)

    def _():
        proxy_state["index"] = (proxy_state["index"] + 1) % num_proxies
        cur_proxy = proxies[proxy_state["index"]]
        return cur_proxy

    return _
