"""
Simple abstractions for data types used when scraping dox sites.
"""

import json
import time

class PostTeaser(object):
    def __init__(self, key):
        self.key = key

class Post(PostTeaser):
    def __init__(self, key, text, url):
        super(Post, self).__init__(key)
        self.text = text
        self.url = url
        self.scrape_url = None
        self.added_on = None
        self.expires_on = None
        self.user = None
        self.title = None

    def to_dict(self):
        as_dict = {
            "key": self.key,
            "text": self.text,
            "url": self.url,
            "scrape_url": self.scrape_url,
            "user": self.user,
            "title": self.title,
        }

        if self.added_on:
            as_dict["added_on"] = time.mktime(self.added_on.timetuple())

        if self.expires_on:
            as_dict["expires_on"] = time.mktime(self.expires_on.timetuple())

        return as_dict

    def to_json(self):
        return json.dumps(self.to_dict())
